package com.zswl.dataservicestarter.dao;

import com.zswl.dataservicestarter.dao.base.MongoDao;
import com.zswl.dataservicestarter.domain.DataServiceOrderInfo;
import com.zswl.dataservicestarter.type.DataServiceOrderType;

import java.util.List;

/**
 * 订单信息Dao
 */
public interface DataServiceOrderInfoDao extends MongoDao<DataServiceOrderInfo> {

    DataServiceOrderInfo findTopById(String id);

    DataServiceOrderInfo findTopByHashCode(int hashCode);

    DataServiceOrderInfo findTopByOrderNo(String orderNo);

    /**
     * 查询未同步到商铺的数据
     *
     * @param orderType
     * @param isSync2Shop
     * @return
     */
    List<DataServiceOrderInfo> findTop100ByOrderTypeAndIsSync2ShopOrderByCreateTimeAsc(DataServiceOrderType orderType, Boolean isSync2Shop);

    /**
     * 统计未同步到商铺的数据
     *
     * @param orderType
     * @param isSync2Shop
     * @return
     */
    long countByOrderTypeAndIsSync2Shop(DataServiceOrderType orderType, Boolean isSync2Shop);

    /**
     * 查询未同步到平台的数据
     *
     * @param orderType
     * @param isSync2Platform
     * @return
     */
    List<DataServiceOrderInfo> findTop100ByOrderTypeAndIsSync2PlatformOrderByCreateTimeAsc(DataServiceOrderType orderType, Boolean isSync2Platform);

    /**
     * 统计未同步到平台的数据
     *
     * @param orderType
     * @param isSync2Platform
     * @return
     */
    long countByOrderTypeAndIsSync2Platform(DataServiceOrderType orderType, Boolean isSync2Platform);

    List<DataServiceOrderInfo> findByOrderNoIn(List<String> orderNos);

}
